Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal.py	(revision 12288)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal.py	(revision 12311)
@@ -123,15 +1094,49 @@
                     ]},
             "transactions": [{
-                    "amount": {
-                        "total": "7.47",
-                        "currency": "USD",
-                        "details": {
-                            "subtotal": "7.41",
-                            "tax": "0.03",
-                            "shipping": "0.03"}},
-                    "description": ("This is the payment "
-                                    "transaction description.")
-                    }]
+                "amount": {
+                    "total": "7.47",
+                    "currency": "USD",
+                    "details": {
+                        "subtotal": "7.41",
+                        "tax": "0.03",
+                        "shipping": "0.03"}},
+                "description": ("This is the payment "
+                                "transaction description.")
+                }]
             }
         )
     return payment
+
+
+class IPayPalPayment(IPayment):
+    """A paypal payment.
+    """
+
+
+class PayPalPayment(grok.Model):
+    """A paypal payment.
+    """
+    pass
+
+
+class PayPalCreditCardService(grok.GlobalUtility):
+    grok.implements(IPaymentGatewayService)
+    grok.name('paypal_creditcard')
+
+    title = _(u'Credit Card (PayPal)')
+
+    def create_payment(self, payer, payment_item,  payee=None):
+        if not IPayer.providedBy(payer):
+            payer = IPayer(payer)
+        if not IPaymentItem.providedBy(payment_item):
+            payment_item = IPaymentItem(payment_item)
+        return None
+        payment = get_payment()
+        return payment
+
+
+class PayPalRegularPaymentService(grok.GlobalUtility):
+    grok.implements(IPaymentGatewayService)
+    grok.name('paypal_regular')
+
+    title = _(u'PayPal Payment')
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal_countries.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal_countries.py	(revision 12311)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal_countries.py	(revision 12311)
@@ -0,0 +1,206 @@
+from waeup.ikoba.interfaces import MessageFactory as _
+from waeup.ikoba.interfaces import SimpleIkobaVocabulary
+
+
+#: A list of country codes as accepted by PayPal
+COUNTRIES = {
+    'AD': _('ANDORRA'),
+    'AE': _('UNITED ARAB EMIRATES'),
+    'AG': _('ANTIGUA AND BARBUDA'),
+    'AI': _('ANGUILLA'),
+    'AL': _('ALBANIA'),
+    'AM': _('ARMENIA'),
+    'AN': _('NETHERLANDS ANTILLES'),
+    'AO': _('ANGOLA'),
+    'AR': _('ARGENTINA'),
+    'AT': _('AUSTRIA'),
+    'AU': _('AUSTRALIA'),
+    'AW': _('ARUBA'),
+    'AZ': _('AZERBAIJAN'),
+    'BA': _('BOSNIA-HERZEGOVINA'),
+    'BB': _('BARBADOS'),
+    'BE': _('BELGIUM'),
+    'BF': _('BURKINA FASO'),
+    'BG': _('BULGARIA'),
+    'BH': _('BAHRAIN'),
+    'BI': _('BURUNDI'),
+    'BJ': _('BENIN'),
+    'BM': _('BERMUDA'),
+    'BN': _('BRUNEI DARUSSALAM'),
+    'BO': _('BOLIVIA'),
+    'BR': _('BRAZIL'),
+    'BS': _('BAHAMAS'),
+    'BT': _('BHUTAN'),
+    'BW': _('BOTSWANA'),
+    'BZ': _('BELIZE'),
+    'CA': _('CANADA'),
+    'CD': _('DEMOCRATIC REPUBLIC OF CONGO'),
+    'CG': _('CONGO'),
+    'CH': _('SWITZERLAND'),
+    'CK': _('COOK ISLANDS'),
+    'CL': _('CHILE'),
+    'CN': _('CHINA (domestic Chinese bank transactions only)'),
+    'C2': _('CHINA (For CUP, bank card and cross-border transactions)'),
+    'CO': _('COLOMBIA'),
+    'CR': _('COSTA RICA'),
+    'CV': _('CAPE VERDE'),
+    'CY': _('CYPRUS'),
+    'CZ': _('CZECH REPUBLIC'),
+    'DE': _('GERMANY'),
+    'DJ': _('DJIBOUTI'),
+    'DK': _('DENMARK'),
+    'DM': _('DOMINICA'),
+    'DO': _('DOMINICAN REPUBLIC'),
+    'DZ': _('ALGERIA'),
+    'EC': _('ECUADOR'),
+    'EE': _('ESTONIA'),
+    'EG': _('EGYPT'),
+    'ER': _('ERITERIA'),
+    'ES': _('SPAIN'),
+    'ET': _('ETHIOPIA'),
+    'FI': _('FINLAND'),
+    'FJ': _('FIJI'),
+    'FK': _('FALKLAND ISLANDS (MALVINAS)'),
+    'FM': _('MICRONESIA, FEDERATED STATES OF'),
+    'FR': _('FRANCE'),
+    'GA': _('GABON'),
+    'GB': _('UNITED KINGDOM'),
+    'GD': _('GRENADA'),
+    'GE': _('GEORGIA'),
+    'GF': _('FRENCH GUIANA'),
+    'GI': _('GIBRALTAR'),
+    'GL': _('GREENLAND'),
+    'GM': _('GAMBIA'),
+    'GN': _('GUINEA'),
+    'GP': _('GUADELOUPE'),
+    'GR': _('GREECE'),
+    'GT': _('GUATEMALA'),
+    'GU': _('GUAM'),
+    'GW': _('GUINEA BISSAU'),
+    'GY': _('GUYANA'),
+    'HK': _('HONG KONG'),
+    'HN': _('HONDURAS'),
+    'HR': _('CROATIA'),
+    'HU': _('HUNGARY'),
+    'ID': _('INDONESIA'),
+    'IE': _('IRELAND'),
+    'IL': _('ISRAEL'),
+    'IN': _('INDIA'),
+    'IS': _('ICELAND'),
+    'IT': _('ITALY'),
+    'JM': _('JAMAICA'),
+    'JO': _('JORDAN'),
+    'JP': _('JAPAN'),
+    'KE': _('KENYA'),
+    'KG': _('KYRGYZSTAN'),
+    'KH': _('CAMBODIA'),
+    'KI': _('KIRIBATI'),
+    'KM': _('COMOROS'),
+    'KN': _('SAINT KITTS AND NEVIS'),
+    'KR': _('SOUTH KOREA'),
+    'KW': _('KUWAIT'),
+    'KY': _('CAYMAN ISLANDS'),
+    'KZ': _('KAZAKHSTAN'),
+    'LA': _('LAOS'),
+    'LC': _('SAINT LUCIA'),
+    'LI': _('LIECHTENSTEIN'),
+    'LK': _('SRI LANKA'),
+    'LS': _('LESOTHO'),
+    'LT': _('LITHUANIA'),
+    'LU': _('LUXEMBOURG'),
+    'LV': _('LATVIA'),
+    'MA': _('MOROCCO'),
+    'MG': _('MADAGASCAR'),
+    'MH': _('MARSHALL ISLANDS'),
+    'ML': _('MALI'),
+    'MN': _('MONGOLIA'),
+    'MQ': _('MARTINIQUE'),
+    'MR': _('MAURITANIA'),
+    'MS': _('MONTSERRAT'),
+    'MT': _('MALTA'),
+    'MU': _('MAURITIUS'),
+    'MV': _('MALDIVES'),
+    'MW': _('MALAWI'),
+    'MX': _('MEXICO'),
+    'MY': _('MALAYSIA'),
+    'MZ': _('MOZAMBIQUE'),
+    'NA': _('NAMIBIA'),
+    'NC': _('NEW CALEDONIA'),
+    'NE': _('NIGER'),
+    'NF': _('NORFOLK ISLAND'),
+    'NI': _('NICARAGUA'),
+    'NL': _('NETHERLANDS'),
+    'NO': _('NORWAY'),
+    'NP': _('NEPAL'),
+    'NR': _('NAURU'),
+    'NU': _('NIUE'),
+    'NZ': _('NEW ZEALAND'),
+    'OM': _('OMAN'),
+    'PA': _('PANAMA'),
+    'PE': _('PERU'),
+    'PF': _('FRENCH POLYNESIA'),
+    'PG': _('PAPUA NEW GUINEA'),
+    'PH': _('PHILIPPINES'),
+    'PL': _('POLAND'),
+    'PM': _('SAINT PIERRE AND MIQUELON'),
+    'PN': _('PITCAIRN'),
+    'PT': _('PORTUGAL'),
+    'PW': _('PALAU'),
+    'QA': _('QATAR'),
+    'RE': _('REUNION'),
+    'RO': _('ROMANIA'),
+    'RS': _('SERBIA'),
+    'RU': _('RUSSIAN FEDERATION'),
+    'RW': _('RWANDA'),
+    'SA': _('SAUDI ARABIA'),
+    'SB': _('SOLOMON ISLANDS'),
+    'SC': _('SEYCHELLES'),
+    'SE': _('SWEDEN'),
+    'SG': _('SINGAPORE'),
+    'SH': _('SAINT HELENA'),
+    'SI': _('SLOVENIA'),
+    'SJ': _('SVALBARD AND JAN MAYEN'),
+    'SK': _('SLOVAKIA'),
+    'SL': _('SIERRA LEONE'),
+    'SM': _('SAN MARINO'),
+    'SN': _('SENEGAL'),
+    'SO': _('SOMALIA'),
+    'SR': _('SURINAME'),
+    'ST': _('SAO TOME AND PRINCIPE'),
+    'SV': _('EL SALVADOR'),
+    'SZ': _('SWAZILAND'),
+    'TC': _('TURKS AND CAICOS ISLANDS'),
+    'TD': _('CHAD'),
+    'TG': _('TOGO'),
+    'TH': _('THAILAND'),
+    'TJ': _('TAJIKISTAN'),
+    'TM': _('TURKMENISTAN'),
+    'TN': _('TUNISIA'),
+    'TO': _('TONGA'),
+    'TR': _('TURKEY'),
+    'TT': _('TRINIDAD AND TOBAGO'),
+    'TV': _('TUVALU'),
+    'TW': _('TAIWAN, PROVINCE OF CHINA'),
+    'TZ': _('TANZANIA, UNITED REPUBLIC OF'),
+    'UA': _('UKRAINE'),
+    'UG': _('UGANDA'),
+    'US': _('UNITED STATES'),
+    'UY': _('URUGUAY'),
+    'VA': _('HOLY SEE (VATICAN CITY STATE)'),
+    'VC': _('SAINT VINCENT AND THE GRENADINES'),
+    'VE': _('VENEZUELA'),
+    'VG': _('VIRGIN ISLANDS, BRITISH'),
+    'VN': _('VIETNAM'),
+    'VU': _('VANUATU'),
+    'WF': _('WALLIS AND FUTUNA'),
+    'WS': _('SAMOA'),
+    'YE': _('YEMEN'),
+    'YT': _('MAYOTTE'),
+    'ZA': _('SOUTH AFRICA'),
+    'ZM': _('ZAMBIA'),
+    }
+
+
+#: A vocabulary of paypal supported countries
+COUNTRIES_VOCAB = SimpleIkobaVocabulary(
+    *[(val, key) for key, val in COUNTRIES.items()])
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal_currencies.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal_currencies.py	(revision 12311)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/paypal_currencies.py	(revision 12311)
@@ -0,0 +1,63 @@
+# $Id$
+#
+# Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+#
+from waeup.ikoba.interfaces import MessageFactory as _
+from waeup.ikoba.interfaces import SimpleIkobaVocabulary
+
+#: The currencies accepted by PayPal.
+#: The entries represent:
+#:   ( title (i18nized), domestic_only, decimals_allowed)
+#:
+#: If `domestic_only` is True, then this currency is supported as a
+#: payment currency and a currency balance for in-country PayPal
+#: accounts only.
+#:
+#: If `decimals_allowed` is *not* True, then you cannot pass amounts
+#: with decimals.
+#:
+#: Status of 2014-12-11
+CURRENCIES = {
+    'AUD': (_(u'Australian dollar'), False, True),
+    'BRL': (_(u'Brazilian real'), True, True),
+    'CAD': (_(u'Canadian dollar'), False, True),
+    'CHF': (_(u'Swiss franc'), False, True),
+    'CZK': (_(u'Czech koruna'), False, True),
+    'DKK': (_(u'Danish krone'), False, True),
+    'EUR': (_(u'Euro'), False, True),
+    'GBP': (_(u'Pound sterling'), False, True),
+    'HKD': (_(u'Hong Kong dollar'), False, True),
+    'HUF': (_(u'Hungarian forint'), False, True),
+    'ILS': (_(u'Israeli new shekel'), False, True),
+    'JPY': (_(u'Japanese yen'), False, False),
+    'MXN': (_(u'Mexican peso'), False, True),
+    'MYR': (_(u'Malaysian ringgit'), True, True),
+    'NOK': (_(u'Norwegian krone'), False, True),
+    'NZD': (_(u'New Zealand dollar'), False, True),
+    'PHP': (_(u'Philippine peso'), False, True),
+    'PLN': (_(u'Polish z\u0142oty'), False, True),
+    'SEK': (_(u'Swedish krona'), False, True),
+    'SGD': (_(u'Singapore dollar'), False, True),
+    'THB': (_(u'Thai baht'), False, True),
+    'TRY': (_(u'Turkish lira'), True, True),
+    'TWD': (_(u'New Taiwan dollar'), False, False),
+    'USD': (_(u'United States dollar'), False, True)
+    }
+
+
+#: A vocabulary of paypal supported currencies
+CURRENCIES_VOCAB = SimpleIkobaVocabulary(
+    *[(val[0], key) for key, val in CURRENCIES.items()])
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_container.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_container.py	(revision 12311)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_container.py	(revision 12311)
@@ -0,0 +1,49 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""
+Test the payments/container module.
+"""
+from zope.interface.verify import verifyClass, verifyObject
+from waeup.ikoba.payments.interfaces import IPaymentsContainer
+from waeup.ikoba.payments.container import PaymentsContainer
+from waeup.ikoba.testing import (FunctionalLayer, FunctionalTestCase)
+
+
+class PaymentsContainerTestCase(FunctionalTestCase):
+
+    layer = FunctionalLayer
+
+    def test_interfaces(self):
+        # Make sure the correct interfaces are implemented.
+        self.assertTrue(
+            verifyClass(
+                IPaymentsContainer, PaymentsContainer)
+            )
+        self.assertTrue(
+            verifyObject(
+                IPaymentsContainer, PaymentsContainer())
+            )
+        return
+
+    def test_base(self):
+        # We cannot call the fundamental methods of a base in that case
+        container = PaymentsContainer()
+        self.assertRaises(
+            NotImplementedError, container.archive)
+        self.assertRaises(
+            NotImplementedError, container.clear)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_currencies.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_currencies.py	(revision 12311)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_currencies.py	(revision 12311)
@@ -0,0 +1,49 @@
+import unittest
+from zope.i18nmessageid.message import Message as i18nMessage
+from zope.interface.verify import verifyObject
+from zope.schema.interfaces import IVocabularyTokenized, ITerm
+from waeup.ikoba.payments.currencies import (
+    get_decimal_units, ISO_4217_CURRENCIES, ISO_4217_CURRENCIES_VOCAB,
+    )
+
+
+class CurrenciesTests(unittest.TestCase):
+
+    def test_get_decimal_units(self):
+        # we can get the number of decimals for a currency code
+        assert get_decimal_units('USD') == 2
+        assert get_decimal_units('JPY') == 0
+
+    def test_iso_currencies_no_linebreak(self):
+        # sanity check: make sure we didn't compile linebreaks
+        for key, value in ISO_4217_CURRENCIES.items():
+            assert '\n' not in key
+            assert '\n' not in value[0]
+            assert '\n' not in value[1]
+
+    def test_iso_currencies_types(self):
+        # sanity check: make sure we have the correct types in all tuples
+        for key, value in ISO_4217_CURRENCIES.items():
+            assert isinstance(value[1], i18nMessage)
+            assert isinstance(value[2], int)
+            assert isinstance(value[3], str)
+
+    def test_currencies_vocab_tokenized(self):
+        # we can get ISO currencies as a source suitable for forms etc.
+        verifyObject(IVocabularyTokenized, ISO_4217_CURRENCIES_VOCAB)
+
+    def test_currencies_vocab_i18nized(self):
+        # vocab titles are i18nized
+        result = ISO_4217_CURRENCIES_VOCAB.getTerm('USD')
+        assert ITerm.providedBy(result)
+        self.assertEqual(result.title, u'US Dollar')
+        assert isinstance(result.title, i18nMessage)
+
+    def test_currencies_vocab_tokens_are_string(self):
+        # vocab tokens are simple strings
+        result = ISO_4217_CURRENCIES_VOCAB.getTerm('USD')
+        assert ITerm.providedBy(result)
+        assert result.token == result.value
+        assert result.value == 'USD'
+        assert isinstance(result.token, str)
+        assert isinstance(result.value, str)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_interfaces.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_interfaces.py	(revision 12288)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_interfaces.py	(revision 12311)
@@ -17,11 +17,7 @@
 ##
 """
-Tests for payments.
+Tests for payments interfaces.
 """
-from zope.interface.verify import verifyClass, verifyObject
-from waeup.ikoba.payments.interfaces import (
-    IPaymentsContainer, IOnlinePayment)
-from waeup.ikoba.payments.container import PaymentsContainer
-from waeup.ikoba.payments.payment import OnlinePayment
+from waeup.ikoba.payments.interfaces import PaymentGatewayServicesSource
 from waeup.ikoba.testing import (FunctionalLayer, FunctionalTestCase)
 
@@ -31,29 +27,16 @@
     layer = FunctionalLayer
 
-    def test_interfaces(self):
-        # Make sure the correct interfaces are implemented.
-        self.assertTrue(
-            verifyClass(
-                IPaymentsContainer, PaymentsContainer)
-            )
-        self.assertTrue(
-            verifyObject(
-                IPaymentsContainer, PaymentsContainer())
-            )
-        self.assertTrue(
-            verifyClass(
-                IOnlinePayment, OnlinePayment)
-            )
-        self.assertTrue(
-            verifyObject(
-                IOnlinePayment, OnlinePayment())
-            )
-        return
+    def test_payment_gateway_services_source(self):
+        # the payment gateway services source provides a list of registered
+        # payment gateways
+        source = PaymentGatewayServicesSource()
+        services = list(source)
+        assert len(services) > 0
 
-    def test_base(self):
-        # We cannot call the fundamental methods of a base in that case
-        container = PaymentsContainer()
-        self.assertRaises(
-            NotImplementedError, container.archive)
-        self.assertRaises(
-            NotImplementedError, container.clear)
+    def test_payment_gateway_services_source_title(self):
+        # we can get titles from gateway sources
+        source = PaymentGatewayServicesSource()
+        service1 = list(source)[0]
+        title = source.factory.getTitle(service1)
+        assert title != service1
+        assert isinstance(title, basestring)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_payment.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_payment.py	(revision 12311)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_payment.py	(revision 12311)
@@ -0,0 +1,112 @@
+## $Id$
+##
+## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+import datetime
+import re
+import unittest
+from zope.component import getUtilitiesFor, getSiteManager
+from zope.interface import implements
+from zope.interface.verify import verifyClass, verifyObject
+from waeup.ikoba.payments.interfaces import (
+    IPayment, STATE_UNPAID, STATE_PAID, STATE_FAILED,
+    IPaymentGatewayService,
+    )
+from waeup.ikoba.payments.payment import Payment, get_payment_providers
+
+
+class HelperTests(unittest.TestCase):
+
+    def tearDown(self):
+        # unregister any IPaymentGatewayServices
+        sm = getSiteManager(None)
+        for name, util in getUtilitiesFor(
+            IPaymentGatewayService):
+            sm.unregisterUtility(util, name=name)
+
+    def test_get_payment_providers_no_providers(self):
+        # we can get a dict of all payment providers
+        result = get_payment_providers()
+        assert isinstance(result, dict)
+        assert result == {}
+
+    def test_get_payment_providers(self):
+        # we get any payment providers registered
+        sm = getSiteManager(None)
+
+        class FakeUtil(object):
+            implements(IPaymentGatewayService)
+
+        fake_util = FakeUtil()
+        sm.registerUtility(fake_util, name=u'some_name')
+        result = get_payment_providers()
+        assert isinstance(result, dict)
+        assert result.keys() == ['some_name', ]
+        assert result['some_name'] is fake_util
+
+
+class PaymentTests(unittest.TestCase):
+
+    def test_iface(self):
+        # Payments fullfill any interface contracts
+        obj = Payment()
+        verifyClass(IPayment, Payment)
+        verifyObject(IPayment, obj)
+
+    def test_payment_id_unique(self):
+        # we get unique payment ids
+        p1, p2 = Payment(), Payment()
+        id1, id2 = p1.payment_id, p2.payment_id
+        assert id1 != id2
+
+    def test_payment_id_format(self):
+        # payment ids have a special format: "PAY_<32 hex digits>"
+        id1 = Payment().payment_id
+        assert isinstance(id1, basestring)
+        assert re.match('PAY_[0-9a-f]{32}', id1)
+
+    def test_initial_state_is_unpaid(self):
+        # the initial state of payments is <unpaid>
+        p1 = Payment()
+        assert p1.state == STATE_UNPAID
+
+    def test_approve(self):
+        # we can approve payments
+        p1 = Payment()
+        p1.approve()
+        assert p1.state == STATE_PAID
+        assert p1.payment_date is not None
+        assert isinstance(p1.payment_date, datetime.datetime)
+
+    def test_approve_datetime_given(self):
+        # we can give a datetime
+        p1 = Payment()
+        some_datetime = datetime.datetime(2014, 1, 1, 0, 0, 0)
+        p1.approve(payment_date=some_datetime)
+        assert p1.payment_date == some_datetime
+
+    def test_approve_datetime_automatic(self):
+        # if we do not give a datetime, current one will be used
+        current = datetime.datetime.utcnow()
+        p1 = Payment()
+        p1.approve()
+        assert p1.payment_date >= current
+
+    def test_mark_failed(self):
+        # we can mark payments as failed
+        p1 = Payment()
+        p1.mark_failed()
+        assert p1.state == STATE_FAILED
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_paypal.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_paypal.py	(revision 12288)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/tests/test_paypal.py	(revision 12311)
@@ -16,18 +16,37 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
+import decimal
 import os
+import re
 import shutil
 import tempfile
 import unittest
 import paypalrestsdk
-from zope.component import getGlobalSiteManager, queryUtility
+from zope.component import (
+    getGlobalSiteManager, queryUtility, getUtilitiesFor,
+    )
+from zope.i18nmessageid.message import Message as i18nMessage
+from zope.interface import implements
+from zope.interface.verify import verifyObject, verifyClass
+from zope.schema.interfaces import IVocabularyTokenized, ITerm
 from waeup.ikoba.interfaces import IPayPalConfig
+from waeup.ikoba.payments.interfaces import (
+    IPaymentGatewayService, IPayer, IPayee, IPaymentItem, IPayment,
+    )
 from waeup.ikoba.payments.paypal import (
     get_paypal_config_file_path, parse_paypal_config, get_access_token,
-    configure_sdk, get_payment,
+    configure_sdk, get_payment, Payer, PayerInfo, ShippingAddress,
+    ADDRESS_TYPES_VOCAB, IShippingAddress, Address, IAddress, to_dict,
+    CreditCard, CREDIT_CARD_TYPES_VOCAB, CREDIT_CARD_STATUS_VOCAB,
+    ICreditCard, ICreditCardToken, CreditCardToken, FundingInstrument,
+    AmountDetails, IAmount, Amount, IItem, Item, STOCK_KEEPING_UNITS_VOCAB,
+    IItemList, ItemList, IPaymentOptions, PaymentOptions, ITransaction,
+    Transaction, PAYMENT_OPTION_METHODS_VOCAB, PayPalCreditCardService,
+    PayPalRegularPaymentService,
     )
 from waeup.ikoba.testing import (
     FunctionalLayer, FunctionalTestCase,
     )
+
 
 #
